// vim: foldmethod=marker

//
// BEGIN FLOCK GPL
// 
// Copyright Flock Inc. 2005-2006
// http://flock.com
// 
// This file may be used under the terms of of the
// GNU General Public License Version 2 or later (the "GPL"),
// http://www.gnu.org/licenses/gpl.html
// 
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
// for the specific language governing rights and limitations under the
// License.
// 
// END FLOCK GPL
//


var gTopbarFavoritesDS;

function $T(aID) {
	return $("topbarBrowser").contentDocument.getElementById(aID);
}

function TopbarJSCtx() {
    return $$("topbarBrowser").contentWindow;
}

function flock_TopbarGetFavoritesDS() {
    // Return DS, create if an instance does not exist
    if(!gTopbarFavoritesDS) {
        gTopbarFavoritesDS = new RDFDataSource("rdf:flock-favorites");
    }
    return gTopbarFavoritesDS;
}

function flock_TopbarHideExtensionArea() {
    // show the main Extension UI
    $("flock_TopbarUIExtensionArea").removeAttribute("collapsed");
    // Collapse extension areas
    var extArea = $("flock_TopbarUIExtensionArea");
    for(var i=0;i<extArea.childNodes.length;++i) {
        extArea.childNodes.item(i).setAttribute("hidden", true);
    }
}

function flock_topbarSelectById(aID, aStayOpen ) {
    flock_topbarSelect($(aID), aStayOpen);
}
function flock_topbarSelect(aObj, aStayOpen) {/*{{{*/
    var topbarBrowser = $("topbarBrowser");
    if (aObj.getAttribute("checked")) {
        if (aStayOpen) return;
        try {
            if(topbarBrowser.contentWindow.onunload) {
                topbarBrowser.contentWindow.onunload();
            }
            if(topbarBrowser.contentWindow.topbarUnload) {
                    topbarBrowser.contentWindow.topbarUnload();
            }
        } catch(e) {
        }
        $('topbar').setAttribute("hidden", true);
        topbarBrowser.setAttribute("src", "");
        aObj.removeAttribute("checked");
        return;
    }
    var topbars = $('flock_TopbarBroadcasterSet').childNodes;
    for (i = 0; i < topbars.length; ++i) {
        var item = topbars[i];
        if (item.getAttribute('checked')) {
            item.removeAttribute('checked');   
        }
    }
    
    flock_TopbarHideExtensionArea();

    // Setup extension area
    var extID = aObj.getAttribute("extID")
    if(extID) {
        if($(extID)) {
            $(extID).removeAttribute("hidden");
        }
        else {
            alert("Error! You havn't properly specified extID in your topbar");
        }
    }
    
    var url = aObj.getAttribute("url")
    if(url) {
        if(url != topbarBrowser.getAttribute("src")) {
        /*
            try {
               if(topbarBrowser.contentWindow.onunload) {
                        topbarBrowser.contentWindow.onunload();
               }
               if(topbarBrowser.contentWindow.topbarUnload) {
                        topbarBrowser.contentWindow.topbarUnload();
               }
            } catch(e) { }
            */
            var height = aObj.getAttribute("topbarHeight");
            if(height) {
                $('topbarBox').setAttribute("height", height);
            }
            $('topbar').removeAttribute("hidden");

            topbarBrowser.setAttribute("src", url);
        } else { }
        aObj.setAttribute("checked","true");
    } else {
        $('topbar').setAttribute("hidden", true);
        topbarBrowser.setAttribute("src", "");
    }
    var onselect = aObj.getAttribute("onselect")
    if(onselect) {
        eval(onselect);
    }
    var value = aObj.getAttribute("value");
}/*}}}*/


